#!/bin/sh /etc/rc.common
-# Copyright (C) 2006-2009 OpenWrt.org
+# Copyright (C) 2006-2010 OpenWrt.org
# Copyright (C) 2006 Carlos Sobrinho
NAME=dropbear
PROG=/usr/sbin/dropbear
START=50
+STOP=50
PIDCOUNT=0
EXTRA_COMMANDS="killclients"
EXTRA_HELP=" killclients Kill ${NAME} processes except servers and yourself"
dropbear_start()
{
+ append_ports()
+ {
+ local ifname="$1"
+ local port="$2"
+
+ grep -qs "^ *$ifname:" /proc/net/dev || {
+ append args "-p $port"
+ return
+ }
+
+ for addr in $(
+ ifconfig "$ifname" | sed -ne '
+ /addr: *fe[89ab][0-9a-f]:/d
+ s/.* addr: *\([0-9a-f:\.]*\).*/\1/p
+ '
+ ); do
+ append args "-p $addr:$port"
+ done
+ }
+
+
local section="$1"
# check if section is enabled (default)
# increase pid file count to handle multiple instances correctly
PIDCOUNT="$(( ${PIDCOUNT} + 1))"
- # prepare parameters
+ # prepare parameters (initialise with pid file)
+ local args="-P /var/run/${NAME}.${PIDCOUNT}.pid"
+ local val
# A) password authentication
- local nopasswd
- local passauth
- config_get_bool passauth "${section}" PasswordAuth 1
- [ "${passauth}" -eq 0 ] && nopasswd=1
- # B) listen port
+ config_get_bool val "${section}" PasswordAuth 1
+ [ "${val}" -eq 0 ] && append args "-s"
+ # B) listen interface and port
local port
- config_get port "${section}" Port
+ local interface
+ config_get interface "${section}" Interface
+ config_get interface "${interface}" ifname "$interface"
+ config_get port "${section}" Port 22
+ append_ports "$interface" "$port"
# C) banner file
- local bannerfile
- config_get bannerfile ${section} BannerFile
- [ -f $bannerfile ] || bannerfile=''
-
- # concatenate parameters
- local args
- args="${nopasswd:+-s }${port:+-p ${port} }${bannerfile:+-b $bannerfile }-P /var/run/${NAME}.${PIDCOUNT}.pid"
+ config_get val "${section}" BannerFile
+ [ -f "${val}" ] && append args "-b ${val}"
+ # D) gatewayports
+ config_get_bool val "${section}" GatewayPorts 0
+ [ "${val}" -eq 1 ] && append args "-a"
+ # E) root password authentication
+ config_get_bool val "${section}" RootPasswordAuth 1
+ [ "${val}" -eq 0 ] && append args "-g"
+ # F) root login
+ config_get_bool val "${section}" RootLogin 1
+ [ "${val}" -eq 0 ] && append args "-w"
+ # G) host keys
+ config_get val "${section}" rsakeyfile
+ [ -f "${val}" ] && append args "-r ${val}"
+ config_get val "${section}" dsskeyfile
+ [ -f "${val}" ] && append args "-d ${val}"
# execute program and return its exit code
[ "${verbosed}" -ne 0 ] && echo "${initscript}: section ${section} starting ${PROG} ${args}"
[ -s /etc/dropbear/dropbear_rsa_host_key -a \
-s /etc/dropbear/dropbear_dss_host_key ] || keygen
+ include /lib/network
+ scan_interfaces
config_load "${NAME}"
config_foreach dropbear_start dropbear
}
local pidfile
for pidfile in `ls /var/run/${NAME}.*.pid`
do
- start-stop-daemon -K -s KILL -p "${pidfile}" -n "${NAME}" >/dev/null
+ start-stop-daemon -q -K -s KILL -p "${pidfile}" -n "${NAME}"
rm -f "${pidfile}"
done
[ -z "${pidfile}" ] && echo "${initscript}: no pid files, if you get problems with start then try killclients"
[ "${pid}" -eq 0 ] && break
# check if client connection
- ps | grep -e "^[ ]*${pid} " | grep "${PROG}" >/dev/null
- if [ $? -eq 0 ]
- then
+ grep -F -q -e "${PROG}" "/proc/${pid}/cmdline" && {
append ignore "${pid}"
break
- fi
+ }
done
# get all server pids that should be ignored
local skip
for pid in `pidof "${NAME}"`
do
- # check if correct program
- ps | grep -e "^[ ]*${pid} " | grep "${PROG}" >/dev/null
- [ $? -ne 0 ] && continue
+ # check if correct program, otherwise process next pid
+ grep -F -q -e "${PROG}" "/proc/${pid}/cmdline" || {
+ continue
+ }
# check if pid should be ignored (servers, ourself)
skip=0